Haketilo - Bug #131

accounts-fedoraproject-org-fix works with Haketilo 2.0, but not Haketilo 3.0b1
10/25/2022 03:04 AM - jacobk
Target version:

Description

| was playing around with Haketilo 3.0b1 and the Epiphany web browser (which doesn't itself support disabling JavaScript), and |
noticed the Fedora account registration fix does not properly enable changing between the "Login" and "Register" tab, as is required
for registration. | later tested this in a clean Abrowser proflile (with the only settings change to connect to the proxy), and | found the
same issue.

| wasn't sure whether to mark this as a bug with this specific site fix or a bug with the proxy, but | think it's more likely to be a proxy
bug because the fix still works with Haketilo 2.0 (as far as | can tell without actually registering).

Here's a log from the Abrowser developer console on the clean profile configured to connect to the Haketilo proxy (which is running
via the relocatable binary):

Content Security Policy: Not supporting directive ‘script-src-elem’. Directive and values will be

ignored.
Content Security Policy: Not supporting directive ‘script-src-attr’. Directive and values will be
ignored.
Content Security Policy: Not supporting directive ‘script-src-elem’. Directive and values will be
ignored.

Content Security Policy: Not supporting directive ‘script-src-attr’. Directive and values will be
ignored.

Loading failed for the <script> with source “https://accounts.fedoraproject.org/theme/static/Jjs/jq
uery/jquery—-3.3.1.min. js”. accounts.fedoraproject.org:346:1

Loading failed for the <script> with source “https://accounts.fedoraproject.org/theme/static/js/fe
dora-bootstrap/fedora-bootstrap.min. js”. accounts.fedoraproject.org:347:1

Content Security Policy: The page’s settings blocked the loading of a resource at https://accounts
.fedoraproject.org/theme/static/js/jquery/jguery-3.3.1.min.js (“script-src”).

Content Security Policy: The page’s settings blocked the loading of a resource at https://accounts
.fedoraproject.org/theme/static/js/fedora-bootstrap/fedora-bootstrap.min.js (“script-src”).
Content Security Policy: The page’s settings blocked the loading of a resource at https://accounts
.fedoraproject.org/-00vafBtudl/api/page_init_script.js (“script-src”).

Content Security Policy: The page’s settings blocked the loading of a resource at https://accounts
.fedoraproject.org/-00vafBtud0/static/accounts-fedoraproject-org-fix/fedoraaccounts.js (“script-sr
c”) .

Loading failed for the <script> with source “https://accounts.fedoraproject.org/-00vafBtud0/api/pa
ge_init_script.js”. accounts.fedoraproject.org:353:1

Loading failed for the <script> with source “https://accounts.fedoraproject.org/-00vafBtudl/static
/accounts-fedoraproject-org-fix/fedoraaccounts. js”. accounts.fedoraproject.org:353:1

| have attached a HAR file that corresponds to the above log.

| suspect the issue has something to do with the website's actual CSP headers, and Haketilo isn't properly removing the ones that
would block the injected scripts? But that's just a guess.

| told Haketilo to enable the fix when it asked the first time | went to the page while connected to the proxy (This was with Epiphany,
but | wouldn't think that would matter.).

History

#1 - 10/25/2022 05:00 PM - koszko
| see where the bug is. | indeed failed to remove the original CSP of the page. If you look at the HTTP response, you'll see 2 CSP headers.
content-security-policy: default-src 'self'; script-src 'strict-dynamic' 'nonce-9JqJAHhiLSWHWgcsPgXN-_I1IgLKA2
xb'; img-src 'self' seccdn.libravatar.org pagure.io; style-src 'self' 'nonce-9JgJAHhiLSWHWgcsPgXN-_I1IgLKA2xDb'

content-security-policy: script-src https://accounts.fedoraproject.org/-00vafBtud0/; script-src-elem 'none'; s
cript-src-attr 'none'

The first one comes from the site. The one at the bottom comes from the proxy.
| can't believe | committed such a big overlooking :0 Anyway, my CSP handling code wasn't super-clean either so | refactored it last week. The fix

seems to work properly with the current version. You can try building Haketilo from git checkout (as suggested in the other issue) or you can wait for
3.0-beta2 to have things work more smoothly. | intend to upload beta2 before the end of this month (i.e. before NLnet grant ends)

#2 - 10/27/2022 01:12 AM - jacobk

Yep, after building with the latest koszko branch, the Fedora account page seems to work fine (I didn't actually try to register, but the tabs work fine.).
#3 - 10/27/2022 11:35 AM - koszko

- % Done changed from 0 to 100

- Status changed from New to Closed

jacobk wrote:

Yep, after building with the latest koszko branch, the Fedora account page seems to work fine (I didn't actually try to register, but the tabs work
fine.).

Actually, | recall tabs were the only thing that had to be fixed there :) Anyway, | assume | can close this now
